%global momorel 2

%define usecache 0
%define cache /var/cache/man

Summary: A set of documentation tools: man, apropos and whatis
Name: man
Version: 1.6e
Release: %{momorel}m%{?dist}

License: GPL
Group: System Environment/Base
URL: http://primates.ximian.com/~flucifredi/man/
Source0: http://primates.ximian.com/~flucifredi/man/man-%{version}.tar.gz
Source1: makewhatis.cronweekly
Source2: makewhatis.crondaily
Source3: mess.ru
Patch1: man-1.5m2-confpath.patch
Patch2: man-1.5h1-make.patch
Patch6: man-1.5m2-apropos.patch
Patch10: man-1.6e-i18n_makewhatis.patch
Patch12: man-1.5m2-posix.patch
Patch18: man-1.5p-pipe_makewhatis.patch
Patch19: man-1.5p-sec.patch
Patch20: man-1.5p-xorg.patch
Patch21: man-1.6b-i18n_nroff.patch
Patch22: man-1.6b-man-pages.patch
Patch23: man-1.6b-rpm.patch
Patch24: man-1.6c-disp.patch
Patch25: man-1.6d-dashes.patch
Patch26: man-1.6d-updates.patch
Patch27: man-1.6e-chmod.patch

Buildroot: %{_tmppath}/%{name}-%{version}-root
Requires: coreutils
Requires: less, groff >= 1:1.18, nroff-i18n, findutils, mktemp >= 1.5-3m
Requires: bzip2, gzip, diffutils, rpm
BuildRequires: less, groff

%description
The man package includes three tools for finding information and/or
documentation about your Linux system: man, apropos, and whatis. The
man system formats and displays on-line manual pages about commands or
functions on your system. Apropos searches the whatis database
(containing short descriptions of system commands) for a string.
Whatis searches its own database for a complete word.

The man package should be installed on your system because it is the
primary way to find documentation on a Linux system.

%prep
%setup -q
%patch1 -p1 -b .confpath
%patch2 -p1 -b .make
%patch6 -p1 -b .apropos
%patch10 -p1 -b .i18n_makewhatis
%patch12 -p1 -b .posix
%patch18 -p1 -b .pipe
%patch19 -p1 -b .sec
%patch20 -p1 -b .xorg
%patch21 -p1 -b .i18n_nroff
%patch22 -p1 -b .up 
%patch23 -p1 -b .rpm
%patch24 -p1 -b .disp
%patch25 -p1 -b .dash
%patch26 -p1 -b .upd
%patch27 -p1 -b .chmod

cp -f %{SOURCE3} msgs   # replace bad ru trans

for src in $(find msgs -type f -name 'mess.[a-z][a-z]'); do
   lang=$(echo ${src} | sed -r 's;.*([a-z]{2})$;\1;')
   if   [ ${lang} = ja ]; then charset=euc-jp
   elif [ ${lang} = ko ]; then charset=euc-kr
   elif [ ${lang} = ru ]; then charset=koi8-r
   elif [ ${lang} = da ]; then charset=iso-8859-1
   elif [ ${lang} = de ]; then charset=iso-8859-1
   elif [ ${lang} = en ]; then charset=iso-8859-1
   elif [ ${lang} = es ]; then charset=iso-8859-1
   elif [ ${lang} = fi ]; then charset=iso-8859-1
   elif [ ${lang} = fr ]; then charset=iso-8859-1
   elif [ ${lang} = it ]; then charset=iso-8859-1
   elif [ ${lang} = pt ]; then charset=iso-8859-1
   elif [ ${lang} = nl ]; then charset=iso-8859-1
   elif [ ${lang} = cs ]; then charset=iso-8859-2
   elif [ ${lang} = hr ]; then charset=iso-8859-2
   elif [ ${lang} = pl ]; then charset=iso-8859-2
   elif [ ${lang} = ro ]; then charset=iso-8859-2
   elif [ ${lang} = sl ]; then charset=iso-8859-2
   elif [ ${lang} = bg ]; then charset=cp1251
   elif [ ${lang} = el ]; then charset=iso-8859-7
   else
      echo === LANGUAGE ${lang}: MUST SPECIFY CHARSET/ENCODING
      exit 1
   fi
   iconv -t utf-8 -f ${charset} -o ${src}.utf ${src} && mv ${src}.utf ${src}
done

%build
./configure -default  -confdir %{_sysconfdir} +fhs +lang all 

find . -type f|xargs perl -pi -e 's,man\.conf \(5\),man.config (5),g'
for i in $(find man -name man.conf.man); do
   mv $i ${i%man.conf.man}man.config.5
done

# HACK: Make output default to using -c; otherwise it appears broken.
perl -pi -e "s/nroff /nroff -c /" conf_script

touch Makefile   # make sure Make thinks we ran configure
make CC="gcc %{optflags}"
%if %{usecache}
cat src/man.conf |sed -e "s,^NOCACHE,# NOCACHE,g" > man.conf
%endif

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_sysconfdir}/cron.{daily,weekly}
mkdir -p %{buildroot}%{_bindir} %{buildroot}%{_sbindir}
make install PREFIX=%{buildroot}

mkdir -p %{buildroot}%{_mandir}/man1
mkdir -p %{buildroot}%{_mandir}/man5
mkdir -p %{buildroot}%{_mandir}/man8
mkdir -p %{buildroot}%{_sysconfdir}

for src in $(find man -type f -name '*.[1-9n]'); do
   lang=$(echo ${src} | sed -r 's;.*/([a-z]{2})/.*;\1;')
   page=$(basename ${src})
   sect=$(echo ${page} | sed -r 's;.*([1-9n])$;man\1;')
   dir=${RPM_BUILD_ROOT}%{_mandir}
   if   [ ${lang} = ja ]; then charset=euc-jp
   elif [ ${lang} = ko ]; then charset=euc-kr
   elif [ ${lang} = da ]; then charset=iso-8859-1
   elif [ ${lang} = de ]; then charset=iso-8859-1
   elif [ ${lang} = en ]; then charset=iso-8859-1
   elif [ ${lang} = es ]; then charset=iso-8859-1
   elif [ ${lang} = fi ]; then charset=iso-8859-1
   elif [ ${lang} = fr ]; then charset=iso-8859-1
   elif [ ${lang} = it ]; then charset=iso-8859-1
   elif [ ${lang} = pt ]; then charset=iso-8859-1
   elif [ ${lang} = nl ]; then charset=iso-8859-1
   elif [ ${lang} = cs ]; then charset=iso-8859-2
   elif [ ${lang} = hr ]; then charset=iso-8859-2
   elif [ ${lang} = pl ]; then charset=iso-8859-2
   elif [ ${lang} = ro ]; then charset=iso-8859-2
   elif [ ${lang} = sl ]; then charset=iso-8859-2
   elif [ ${lang} = bg ]; then charset=cp1251
   elif [ ${lang} = el ]; then charset=iso-8859-7
   else
      echo === LANGUAGE ${lang}: MUST SPECIFY CHARSET/ENCODING
      exit 1
   fi
   mkdir -p ${dir}/${lang}/${sect}
   iconv -t utf-8 -f ${charset} -o ${dir}/${lang}/${sect}/${page} ${src}

   # ensure POSIX/C locale only has ASCII subset and no latin-1 
   if [ ${lang} = en ]; then
      mkdir -p ${dir}/${sect}
      iconv -t ascii//translit -f ${charset} -o ${dir}/${sect}/${page} ${src}
   fi
done

install -m 644 src/man.conf %{buildroot}%{_sysconfdir}/man.config

install -m755 %{SOURCE1} %{buildroot}%{_sysconfdir}/cron.weekly/makewhatis.cron
install -m755 %{SOURCE2} %{buildroot}%{_sysconfdir}/cron.daily/makewhatis.cron

mkdir -p %{buildroot}/%{cache}

mkdir -p %{buildroot}/%{cache}/local
mkdir -p %{buildroot}/%{cache}/X11R6
for i in 1 2 3 4 5 6 7 8 9 n; do
        mkdir -p %{buildroot}/%{cache}/cat$i
        mkdir -p %{buildroot}/%{cache}/local/cat$i
        mkdir -p %{buildroot}/%{cache}/X11R6/cat$i
done

#strip %{buildroot}%{_bindir}/man 

# added man2html stuff
cd man2html
make install DESTDIR=%{buildroot}
#strip -R .comment %{buildroot}%{_bindir}/man2html

for src in $(find %{buildroot}%{_mandir} -type f -name '*.[1-9n]'); do
   gzip -9 ${src}
done

# symlinks for manpath
( cd %{buildroot}
  ln -s man .%{_bindir}/manpath
  ln -s man.1.gz .%{_mandir}/man1/manpath.1.gz
)

# move makewhatis, allow others to execute
#mv %{buildroot}%{_sbindir}/makewhatis %{buildroot}%{_bindir}
#chmod a+x %{buildroot}%{_bindir}/makewhatis

# remove unpackaged files from the buildroot
rm -f %{buildroot}%{_bindir}/man2dvi
rm -rf %{buildroot}%{_prefix}%{_sysconfdir}

%preun
rm -f %{cache}/cat[123456789n]/* 2>/dev/null || :
rm -f %{cache}/local/cat[123456789n]/* 2>/dev/null || :
rm -f %{cache}/X11R6/cat[123456789n]/* 2>/dev/null || :
rm -f %{cache}/whatis 2>/dev/null || :

%triggerpostun -- man <= 1.5i2-0
rm -f %{cache}/cat[123456789n]/* 2>/dev/null || :
rm -f %{cache}/local/cat[123456789n]/* 2>/dev/null || :
rm -f %{cache}/X11R6/cat[123456789n]/* 2>/dev/null || :
rm -f %{cache}/whatis 2>/dev/null || :
exit 0

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/cron.weekly/makewhatis.cron
%config(noreplace) %{_sysconfdir}/cron.daily/makewhatis.cron
%if %{usecache}
%attr(2755,root,man)    %{_bindir}/man
%else
%attr(0755,root,root)   %{_bindir}/man
%endif
%{_bindir}/manpath
%{_bindir}/apropos
%{_bindir}/whatis
%{_sbindir}/makewhatis
%config(noreplace) %{_sysconfdir}/man.config
%{_mandir}/man5/man.config.5*
%{_mandir}/man1/whatis.1*
%{_mandir}/man1/man.1*
%{_mandir}/man1/manpath.1*
%{_mandir}/man1/apropos.1*
%{_mandir}/man1/man2html.1*
%{_mandir}/man8/makewhatis.8*
%{_bindir}/man2html
%lang(bg) %{_datadir}/locale/bg/man
%lang(bg) %dir %{_mandir}/bg
%lang(bg) %{_mandir}/bg/man?
%lang(cs) %{_datadir}/locale/cs/man
%lang(cs) %dir %{_mandir}/cs
%lang(cs) %{_mandir}/cs/man?
%lang(da) %{_datadir}/locale/da/man
%lang(da) %dir %{_mandir}/da
%lang(da) %{_mandir}/da/man?
%lang(de) %{_datadir}/locale/de/man
%lang(de) %dir %{_mandir}/de
%lang(de) %{_mandir}/de/man?
%lang(el) %{_datadir}/locale/el/man
%lang(el) %dir %{_mandir}/el
%lang(el) %{_mandir}/el/man?
%lang(en) %{_datadir}/locale/en/man
%lang(en) %dir %{_mandir}/en
%lang(en) %{_mandir}/en/man?
%lang(es) %{_datadir}/locale/es/man
%lang(es) %dir %{_mandir}/es
%lang(es) %{_mandir}/es/man?
%lang(fi) %{_datadir}/locale/fi/man
%lang(fi) %dir %{_mandir}/fi
%lang(fi) %{_mandir}/fi/man?
%lang(fr) %{_datadir}/locale/fr/man
%lang(fr) %dir %{_mandir}/fr
%lang(fr) %{_mandir}/fr/man?
%lang(hr) %{_datadir}/locale/hr/man
%lang(hr) %dir %{_mandir}/hr
%lang(hr) %{_mandir}/hr/man?
%lang(it) %{_datadir}/locale/it/man
%lang(it) %dir %{_mandir}/it
%lang(it) %{_mandir}/it/man?
%lang(ja) %{_datadir}/locale/ja/man
%lang(ja) %dir %{_mandir}/ja
%lang(ja) %{_mandir}/ja/man?
%lang(ko) %{_datadir}/locale/ko/man
%lang(ko) %dir %{_mandir}/ko
%lang(ko) %{_mandir}/ko/man?
%lang(nl) %{_datadir}/locale/nl/man
%lang(nl) %dir %{_mandir}/nl
%lang(nl) %{_mandir}/nl/man?
%lang(pl) %{_datadir}/locale/pl/man
%lang(pl) %dir %{_mandir}/pl
%lang(pl) %{_mandir}/pl/man?
%lang(pt) %{_datadir}/locale/pt/man
%lang(pt) %dir %{_mandir}/pt
%lang(pt) %{_mandir}/pt/man?
%lang(ro) %{_datadir}/locale/ro/man
%lang(ro) %dir %{_mandir}/ro
%lang(ro) %{_mandir}/ro/man?
%lang(sl) %{_datadir}/locale/sl/man
%lang(sl) %dir %{_mandir}/sl
%lang(sl) %{_mandir}/sl/man?
%lang(ru) %{_datadir}/locale/ru/man
%attr(0755,root,root)   %dir %{cache}
%attr(0755,root,man)    %dir %{cache}/cat[123456789n]
%attr(0755,root,man)    %dir %{cache}/local
%attr(0755,root,man)    %dir %{cache}/local/cat[123456789n]
%attr(0755,root,man)    %dir %{cache}/X11R6
%attr(0755,root,man)    %dir %{cache}/X11R6/cat[123456789n]

%changelog
* Fri Jun 15 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.6e-2m)
- release %%{_datadir}/locale/*, glibc-common provides them

* Fri Jun 15 2007 Masahiro Takahata <takahata@momonga-linux.org>
- (1.6e-1m)
- sync Fedora

* Thu May 25 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (1.5k-7m)
- NoSource to Source

* Thu Jan 18 2007 Ryu SASAOKA <ryu@momonga-linux.org>
- (1.5k-6m)
- noreplace /etc/man.config
- revised spec

* Sun Nov 19 2006 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (1.5k-5m)
- add LANG setting for proper displaying Japanese manual under UTF-8  

* Tue Oct 19 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.5k-4m)
- add Patch25: man-1.5k-gcc33.patch
  reported by Hiromasa YOSHIMOTO [Momonga-devel.ja:02823]

* Tue Dec 24 2002 KOMATSU Shinichiro <koma2@jiro.c.u-tokyo.ac.jp>
- (1.5k-3m)
- Added makewhatis bzip2 support patch (man-1.5k-makewhatis-bzip2.patch).
  (This patch seems to be almost the same as man-1.5i2-makewhatis.patch.
   Why was it removed?)

* Tue Nov 19 2002 OZAWA -Crouton- Sakuro <crouton@momonga-linux.org>
- (1.5k-2m)
- require pager instead of less.

* Fri Jul 19 2002 Kazuhiko <kazuhiko@fdiary.net>
- (1.5k-1m)
- minor security fixes
- change Source0 URI
- revise many patches to avoid reject...

* Sun Apr  7 2002 YAMAZAKI Makoto <zaki@kondara.org>
- (1.5i2-10k)
- change Requires mktemp >=1.5 to >= 1.4-2k

* Thu Nov 15 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (1.5i2-8k)
- modify -mandocj to -mandoc

* Wed Nov 14 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (1.5i2-6k)
- add NLSPATH="" to configure

* Tue Nov 13 2001 Shingo Akagaki <dora@kondara.org>
- (1.5i2-4k)
- forrow up catalog

* Sun Sep 30 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (1.5i2-2k)
- Kondarization from redhat

* Sat May 26 2001 Shingo Akagaki <dora@kondara.org>
- (1.5i-4k)
- for Mary

* Wed May 23 2001 Shintarou Sakai <s_sakai@mxn.mesh.ne.jp>
- (1.5i-3k)
- merge redhat-7.1 (1.5i-4)

* Wed Mar  7 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (1.5h-18k)
- added two patches, i.e. Patch9 and Patch10 for FHS

* Sat Feb 10 2001 Shintarou Sakai <s_sakai@mxn.mesh.ne.jp>
- (1.5h-17k)
- makewhatis remove TMPFILEDIR
- modify Source0 URL and %post 

* Sat Jan 27 2001 Shintarou Sakai <s_sakai@mxn.mesh.ne.jp>
- (1.5h1-15k)
- makewhatis use bzcat

* Fri Oct 20 2000 MATSUDA, Daiki <dyky@df-usa.com>
- (1.5h1-11k)
- fixed typo TT

* Fri Oct 20 2000 MATSUDA, Daiki <dyky@df-usa.com>
- (1.5h1-9k)
- create /var/catman directory in %post

* Tue Jul 18 2000 Bill Nottingham <notting@redhat.com>
- makewhatis makes predicatable filenames in /tmp. Bad.

* Wed Jul 05 2000 Toru Hoshina <t@kondara.org>
- rebuild against glibc-2.1.90, X-4.0, rpm-3.0.5.


* Tue May 30 2000 Kenichi Matsubara <m@konadara.org>
- add MANPATH /usr/kde1x/man -> /etc/man.config

* Wed Mar 1 2000 Masako Hattori <maru@kondara.org>
- change jman mv->cp

* Tue Feb 29 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 1.5h1 - this has a better fix for the security problems.
- remove manpath patch (now in base)
- remove loop patch (now in base)

* Mon Feb 28 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix security problems related to buffer overruns caused by oversized
  enviroment variables

* Wed Feb 23 2000 Masako Hattori <maru@kondara.org>
- do not shake %{_mandir}/ja

* Mon Feb 21 2000 Takaaki Tabuchi <tab@kondara.org>
- be able to rebuild non-root user.

* Thu Feb  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- deal with rpm gziping man pages
- fix file locking (Bug #8947)

* Mon Sep 13 1999 Bill Nottingham <notting@redhat.com>
- strip man2html

* Fri Sep 10 1999 Cristian Gafton <gafton@redhat.com>
- revert to latin1 instead of ascii

* Wed Jun 16 1999 Cristian Gafton <gafton@redhat.com>
- fixed man2html loop on terminfo.5 (patrch from the author; #3316)

* Mon May 10 1999 Michael K. Johnson <johnsonm@redhat.com>
- fixed #2532 by adding /usr/local/sbin as a MANPATH_MAP

* Fri Apr 09 1999 Michael K. Johnson <johnsonm@redhat.com>
- cron.weekly rebuilds, cron.daily updates in minimal time

* Fri Apr 09 1999 Preston Brown <pbrown@redhat.com>
- man 1.5g bugfix release

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 5)

* Thu Feb 18 1999 Jeff Johnson <jbj@redhat.com>
- add manpath symlinks (#1138).

* Fri Feb 12 1999 Michael Maher <mike@redhat.com>
- fixed bug #792
- added man2html files

* Tue Dec 29 1998 Cristian Gafton <gafton@redhat.com>
- build for 6.0
- upgraded to 1.5e
- properly buildrooted

* Thu Aug 13 1998 Jeff Johnson <jbj@redhat.com>
- enable fsstnd organization
- change /var/catman/X11 to X11R6
- %post/%preun to clean up cat litter

* Tue Jun 02 1998 Prospector System <bugs@redhat.com>
- translations modified for de

* Tue Jun 02 1998 Erik Troan <ewt@redhat.com>
- you can't do free(malloc(10) + 4) <sigh>

* Wed May 06 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to 1.5d

* Fri Apr 24 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Fri Apr 10 1998 Cristian Gafton <gafton@redhat.com>
- updated to 1.5a

* Sun Oct 19 1997 Erik Troan <ewt@redhat.com>
- uses a build root

* Mon Sep 22 1997 Erik Troan <ewt@redhat.com>
- updated to man-1.4j, which fixes some security problems; release 1 is
  for RH 4.2, release 2 is for glibc
 
* Mon Jun 02 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Tue Mar 25 1997 Erik Troan <ewt@redhat.com>
- Added /usr/lib/perl5/man to default manpath


